package ecp.vcs.com.ecpsyncplugin.re_sync.networking;


import android.content.Context;
import android.util.Log;

import java.io.IOException;
import java.util.concurrent.TimeUnit;

import ecp.vcs.com.ecpsyncplugin.re_sync.SynchronizationService;
import ecp.vcs.com.ecpsyncplugin.re_sync.logging.LogJsonInterceptor;
import okhttp3.Request;
import okhttp3.RequestBody;
import okio.Buffer;
import okio.BufferedSink;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;


/**
 * File Name    : RestClient
 * Description  : This Class set up retrofit net working.
 * Create By    : Value Chain Solution
 * Create At    : 30-05-2017
 * Developed By : VCSDEV0114
 * Modified By  :
 * Feature      :
 *
 * @author Value Chain Soluction Pvt Ltd.
 */

public class RestClient {

    private static APIService REST_CLIENT;

//    private static String token;
//    private static String userID;
//    private static String baseURL;

    public RestClient(String userID,String token) {
        setRestClient(userID,token);
    }

    public APIService get() {
        return REST_CLIENT;
    }

    private void setRestClient(String userID,String token) {
        okhttp3.OkHttpClient.Builder httpClient = new okhttp3.OkHttpClient.Builder();
//        httpClient.retryOnConnectionFailure(false);
        httpClient.addInterceptor(chain -> {
            Request original = chain.request();

            Request request = original.newBuilder()
                    .header("token", token)
                    .header("user_id", userID)
                    .method(original.method(), forceContentLength(original.body()))
                    .build();

            return chain.proceed(request);
        });

        AppUtil.setLogToHttpClient(httpClient);
        //httpClient.addInterceptor(Utils.setLogsToMethod());
        httpClient.readTimeout(20, TimeUnit.MINUTES);
        httpClient.connectTimeout(20, TimeUnit.MINUTES);

        okhttp3.OkHttpClient client = httpClient.addInterceptor(new LogJsonInterceptor()).build();
//        Const.BASE_URL="https://basf-in.ecubix.com/public/";
//        if (Const.BASE_URL.isEmpty()) {
//            String basePath = ServerCofig.isLivePackageBasePath(context);
//            if (!basePath.isEmpty()) {
//                Const.BASE_URL = basePath;
//            } else {
//                String isCQAPackageBasePath = ServerCofig.getCQAPackageBasePath(context);
//                if (!isCQAPackageBasePath.isEmpty()) {
//                    Const.BASE_URL = isCQAPackageBasePath;
//                }
//
//                String isDEVPackageBasePath = ServerCofig.isDEVPackageBasePath(context);
//                if (!isDEVPackageBasePath.isEmpty()) {
//                    Const.BASE_URL = isDEVPackageBasePath;
//                }
//            }
//        }
        Log.e("BASE_URL::::::::", "" + SynchronizationService.BASE_URL_PASS);

        Retrofit retrofit = new Retrofit.Builder()
                .baseUrl(SynchronizationService.BASE_URL_PASS)
                .client(client)
                .addConverterFactory(GsonConverterFactory.create())
                .build();

        REST_CLIENT = retrofit.create(APIService.class);
    }


    private RequestBody forceContentLength(final RequestBody requestBody) {
        try {
            final Buffer buffer = new Buffer();
            requestBody.writeTo(buffer);
            return new RequestBody() {
                @Override
                public okhttp3.MediaType contentType() {
                    return requestBody.contentType();
                }

                @Override
                public long contentLength() {
                    return buffer.size();
                }

                @Override
                public void writeTo(BufferedSink sink) throws IOException {
                    sink.write(buffer.snapshot());
                }
            };
        } catch (IOException e) {
            e.printStackTrace();
        }
        return requestBody;
    }

}

